#pragma once

#include "GPRectangle.h"
#include "GPPoint.h"
#include "gputils.h"

#include <iostream>

using namespace std;

namespace genetic_pack {

	// class representing input data for the problem
	// i.e. metal sheet, defect and rectangles
	class GPContainer
	{
		GPRectangle metalSheet;
		vector<GPPoint> defects;
		vector<GPRectangle> rectangles;

		GPContainer(void);
	public:
		GPContainer(GPRectangle metalSheet, vector<GPPoint> defects, vector<GPRectangle> rectangles);

		const GPRectangle& GetMetalSheet() const { return metalSheet; };
		const vector<GPPoint>& GetDefects() const { return defects; };
		const vector<GPRectangle>& GetRectangles() const { return rectangles; };
	};

	// generating random container
	// for testing
	GPContainer randomContainer(double W, double H, int defectsNum, int rectNum);

	// container output to the output stream
	// for debugging, etc.
	ostream& operator<<(ostream& out, const GPContainer& container);

} // namespace genetic_pack
