#pragma once

#include <iostream>
#include <map>

using namespace std;

namespace genetic_pack {

	class GPParams
	{
	public:
		int crossoverMode; //	enum		JAKOBS_CROSSOVER	alg			Possible modes: JAKOBS_CROSSOVER, PMX_CROSSOVER		
		int layoutMethod; //	enum		simple-layer		alg			Possible methods: simple-layer, advanced-layer
		double mutationProb; //	double		0.1					alg				
		int popSize; //			int			20					alg
		int eliteSize; //		int			5					alg
		int generations; //		int			100					alg
		bool rotateAndRepeat; //bool		false				alg			Whether we could rotate and repeat rectangles

		string ifname; //		string		N/A					external	Filename of the input file
		int tries; //			int			1					external	How many tries to start GA with the particular input data
		bool rotateSheet; //	bool		false				external	Whether we rotate the metal sheet

		GPParams(int argc, char* argv[]);

		void dumpParams(ostream& out) const;
	private:
		map<string, string> pm;
		
		map<string, string> paramsMap(int argc, char* agrv[]);

		void parseString(string key, string& value);
		void parseInt(string key, int& value);
		void parseDouble(string key, double& value);
		void parseBool(string key, bool& value);
	};

}

