#include "GPRandom.h"

#include <cmath>
#include <ctime>

namespace genetic_pack {

	GPRandom::GPRandom(unsigned int seed)
	{ 
		this->seed = (seed == c) ? ((int)time(NULL)) : seed;
		m = exp(-32*log((double)2)); 
	}

	double GPRandom::get()
	{
		seed = a*seed + c;

		return (seed * m);
	}

	int GPRandom::get(int from, int to)
	{
		return (int)(get()*(to - from) + from);
	};

	// global object
	GPRandom random;

	double getRandom()
	{ 
		return random.get();
	}

	int getRandom(int from, int to)
	{
		return random.get(from, to);
	}

} // namespace genetic_pack