#include "GPRectPosition.h"
#include "gputils.h"

namespace genetic_pack {

	GPRectPosition::GPRectPosition(GPRectangle rectangle, GPPoint base): 
		base(base), rectangle(rectangle)
	{
	}

	// calculates coordinates of top-right vertice
	GPPoint GPRectPosition::GetTopRight() const
	{
		GPPoint p;
		p.x = base.x + rectangle.GetWidth();
		p.y = base.y + rectangle.GetHeight();

		return p;
	}

	// all the vertices, clockwise, starting from left-bottom
	vector<GPPoint> GPRectPosition::GetVertices() const
	{
		GPPoint p;
		vector<GPPoint> vertices;
		
		vertices.push_back(base);
		
		p.x = base.x;
		p.y = base.y + rectangle.GetHeight();
		vertices.push_back(p);
		
		vertices.push_back(GetTopRight());

		p.x += rectangle.GetWidth();
		p.y -= rectangle.GetHeight();
		vertices.push_back(p);

		return vertices;
	}

	bool GPRectPosition::operator==(const GPRectPosition& other)
	{
		return compare(base.x, other.base.x) == 0
			&& compare(base.y, other.base.y) == 0
			&& compare(rectangle.GetWidth(), other.rectangle.GetWidth())
			&& compare(rectangle.GetHeight(), other.rectangle.GetHeight());

	}

} // namespace genetic_pack