#pragma once

#include "gppoint.h"
#include "gprectangle.h"

#include <vector>

using std::vector;

namespace genetic_pack {

	// class represents rectangle and its position (coordinates)
	class GPRectPosition
	{
		GPPoint base; // left-bottom point of the rectangle
		GPRectangle rectangle; // rectangle (i.e. width and height)
	public:
		GPRectPosition(GPRectangle rect, GPPoint base);

		const GPPoint& GetBase() const { return base; };
		const GPRectangle& GetRectangle() const { return rectangle; };
		GPPoint GetTopRight() const; // calculates coordinates of top-right vertice
		vector<GPPoint> GetVertices() const; // all the vertices, clockwise, starting from left-bottom

		bool operator==(const GPRectPosition& other);
	};

} // namespace genetic_pack
