#pragma once

// Some general-purpose functions

#include "GPPoint.h"
#include "GPRectPosition.h"

// default level of tolerance
#define TOLERANCE 1E-6

namespace genetic_pack {

	// compares two doubles with TOLERANCE
	// returns:
	//	-1 if a < b
	//	 0 if a = b
	//	 1 if a > b
	int compare(double a, double b);

	// checks if the point is strictly inside the rectangle
	bool isStrictlyInsideRect(const GPPoint& p, const GPRectPosition& rect);

	// checks if the point is on the border of the rectangle
	bool isOnRectBorder(const GPPoint& p, const GPRectPosition& rect);

	// checks if the point is either iside the rectangle or on the border
	bool isOutsideRect(const GPPoint& p, const GPRectPosition& rect);
	
	// checks if two rectangles overlap
	bool isOverlapped(GPRectPosition r1, GPRectPosition r2);
}
